---
title: HTMLMediaElement.srcObject
slug: Web/API/HTMLMediaElement/srcObject
tags:
  - API
  - HTML
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Property
  - Reference
  - srcObject
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>srcObject</code></strong> property of the {{domxref("HTMLMediaElement")}} interface sets or returns the object which serves as the source of the media associated with the {{domxref("HTMLMediaElement")}}.</span> The object can be a {{domxref("MediaStream")}}, a {{domxref("MediaSource")}}, a {{domxref("Blob")}}, or a {{domxref("File")}} (which inherits from <code>Blob</code>).</p>

<div class="note">
<p><strong>Note:</strong> As of March 2020, only Safari supports setting objects other than <code>MediaStream</code>. Until other browsers catch up, for <code>MediaSource</code>, <code>Blob</code> and <code>File</code>, consider falling back to creating a URL with {{domxref("URL.createObjectURL()")}} and assign it to {{domxref("HTMLMediaElement.src")}}. See below for an example.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>sourceObject</em> = <em>HTMLMediaElement</em>.srcObject;

<em>HTMLMediaElement</em>.srcObject = <em>sourceObject</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref('MediaStream')}}, {{domxref('MediaSource')}}, {{domxref('Blob')}}, or {{domxref('File')}} object (though see the compatibility table for what is actually supported).</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Older versions of the Media Source specification required using {{domxref("URL.createObjectURL", "createObjectURL()")}} to create an object URL then setting {{domxref("HTMLMediaElement.src", "src")}} to that URL. Now you can just set <code>srcObject</code> to the {{domxref("MediaStream")}} directly.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>In this example, a {{domxref("MediaStream")}} from a camera is assigned to a newly-created {{HTMLElement("video")}} element.</p>

<pre class="brush: js">const mediaStream = await navigator.mediaDevices.getUserMedia({video: true});
const video = document.createElement('video');
video.srcObject = mediaStream;</pre>

<p>In this example, a new {{domxref('MediaSource')}} is assigned to a newly-created {{HTMLElement("video")}} element.</p>

<pre class="brush: js">const mediaSource = new MediaSource();
const video = document.createElement('video');
video.srcObject = mediaSource;</pre>

<h3 id="Supporting_fallback_to_the_src_property">Supporting fallback to the src property</h3>

<p>The examples below support older browser versions that require you to create an object URL and assign it to <code>src</code> if <code>srcObject</code> isn't supported.</p>

<p>First, a {{domxref("MediaStream")}} from a camera is assigned to a newly-created {{HTMLElement("video")}} element, with fallback for older browsers.</p>

<pre class="brush: js">const mediaStream = await navigator.mediaDevices.getUserMedia({video: true});
const video = document.createElement('video');
if ('srcObject' in video) {
  video.srcObject = mediaStream;
} else {
  // Avoid using this in new browsers, as it is going away.
  video.src = URL.createObjectURL(mediaStream);
}
</pre>

<p>Second, a new {{domxref('MediaSource')}} is assigned to a newly-created {{HTMLElement("video")}} element, with fallback for older browsers and browsers that don't yet support assignment of {{domxref('MediaSource')}} directly.</p>

<pre class="brush:js">const mediaSource = new MediaSource();
const video = document.createElement('video');
// Older browsers may not have srcObject
if ('srcObject' in video) {
  try {
    video.srcObject = mediaSource;
  } catch (err) {
    if (err.name != "TypeError") {
      throw err;
    }
    // Even if they do, they may only support MediaStream
    video.src = URL.createObjectURL(mediaSource);
  }
} else {
  video.src = URL.createObjectURL(mediaSource);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'embedded-content.html#dom-media-srcobject', 'srcObject')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.srcObject")}}</p>
